/*******************************************************************
*
*  DESCRIPTION: Atomic Model Agua
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: joagsa@dc.uba.ar
*
*
*  DATE: 24/09/2004
*
*******************************************************************/
#ifndef __AGUA_H
#define __AGUA_H

/** include files **/
#include "atomic.h"  // class Atomic

/** forward declarations **/
class Distribution ;

/** declarations **/
class Agua: public Atomic
{
public:
	Agua( const string &name = "Agua" ) ;	 // Default constructor

	~Agua();					// Destructor
	enum estado {espera, iniciando, calentando, enviando, fin};
	virtual string className() const
		{return "Agua";}

protected:
	Model &initFunction()
		{    estado = espera;
             cant_agua = 0; //30-60-90
             temp = 0;  //10-40-80
             return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &agua_in ;
	Port &fin_agua ;
    Port &agua_out;

    int estado;
    int cant_agua;
    int temp;


};	// class Agua


#endif    //__AGUA_H
