/*******************************************************************
*
*  DESCRIPTION: Atomic Model Detergente
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: jogasa@dc.uba.ar
*
*
*  DATE: 23/09/2004
*
*******************************************************************/

/** include files **/
#include <math.h>            // fabs( ... )
#include <stdlib.h>           // for rand function.
#include "Detergente.h"     // base header
#include "message.h"        // InternalMessage ....
#include "distri.h"        // class Distribution
#include "mainsimu.h"      // class MainSimulator
#include "strutil.h"       // str2float( ... )

/*******************************************************************
* Function Name: Detergente
* Description: constructor
********************************************************************/
Detergente::Detergente( const string &name )
: Atomic( name )
, det_in( addInputPort( "det_in" ) )
, det_out( addOutputPort( "det_out" ) )
, fin_det( addOutputPort( "fin_det" ) )
{
/*	try
	{
		dist = Distribution::create( MainSimulator::Instance().getParameter( description(), "distribution" ) );

		MASSERT( dist );

		for ( register int i = 0 ; i < dist->varCount() ; i++ )
		{
			string parameter( MainSimulator::Instance().getParameter( description(), dist->getVar(i) ) ) ;
			dist->setVar( i, str2float( parameter ) ) ;
		}
	} catch( InvalidDistribution &e )
	{
		e.addText( "The model " + description() + " has distribution problems!" ) ;
		e.print(cerr);
		MTHROW( e ) ;
	} catch( MException &e )
	{
		MTHROW( e ) ;
	}
*/
}

/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &Detergente::externalFunction( const ExternalMessage &msg )
{
	if (this->estado == espera) {

		this->cant_det = (int) msg.value()  ;
		this->estado = iniciando;
		holdIn(active,0);
	
	} else 
	
	passivate();
	
	
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &Detergente::internalFunction( const InternalMessage & )
{
	if (this->estado == iniciando) {

		this->estado = enviando;
		Time t (0, 0, this->cant_det, 0);
		holdIn(active,t);
	
	} else 
	 
	if (this->estado == enviando){
	
		this->estado = fin;
		holdIn(active,0);

	} else

	if (this->estado == fin) {
		this->cant_det = 0;
		this->estado = espera;
		passivate();
	} else
	
	passivate();
	
	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &Detergente::outputFunction( const InternalMessage &msg )
{
	if (this->estado == iniciando) {

		sendOutput( msg.time(), det_out, this->cant_det );	
	
	} else 
	
	if (this->estado == fin) {

		sendOutput( msg.time(), det_out, 0 );
		sendOutput( msg.time(), fin_det, 1 );	
	
	}

	return *this;
}

Detergente::~Detergente()
{
//	delete dist;
}
