/*******************************************************************
*
*  DESCRIPTION: Atomic Model Motor
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: jogasa@dc.uba.ar
*
*
*  DATE: 23/09/2004
*
*******************************************************************/

/** include files **/
#include <math.h>            // fabs( ... )
#include <stdlib.h>           // for rand function.
#include "Motor.h"     // base header
#include "message.h"        // InternalMessage ....
#include "distri.h"        // class Distribution
#include "mainsimu.h"      // class MainSimulator
#include "strutil.h"       // str2float( ... )

/*******************************************************************
* Function Name: Motor
* Description: constructor
********************************************************************/
Motor::Motor( const string &name )
: Atomic( name )
, motor_in( addInputPort( "motor_in" ) )
, motor_out( addOutputPort( "motor_out" ) )
, fin_motor( addOutputPort( "fin_motor" ) )
{
/*	try
	{
		dist = Distribution::create( MainSimulator::Instance().getParameter( description(), "distribution" ) );

		MASSERT( dist );

		for ( register int i = 0 ; i < dist->varCount() ; i++ )
		{
			string parameter( MainSimulator::Instance().getParameter( description(), dist->getVar(i) ) ) ;
			dist->setVar( i, str2float( parameter ) ) ;
		}
	} catch( InvalidDistribution &e )
	{
		e.addText( "The model " + description() + " has distribution problems!" ) ;
		e.print(cerr);
		MTHROW( e ) ;
	} catch( MException &e )
	{
		MTHROW( e ) ;
	}
*/
}

/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &Motor::externalFunction( const ExternalMessage &msg )
{
	if (this->estado == espera) {

		this->tiempo = (int) msg.value() ;
		this->estado = iniciando;
		holdIn(active,0);
	
	} else 
	
	passivate();
	
	
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &Motor::internalFunction( const InternalMessage & )
{
	if (this->estado == iniciando) {

		this->estado = marchando;
		Time t (0, this->tiempo, 0, 0);
		holdIn(active,t);
	
	} else 
	 
	if (this->estado == marchando){
	
		this->estado = apagando;
		holdIn(active,0);

	} else

	if (this->estado == apagando) {
		this->tiempo = 0;
		this->estado = espera;
		passivate();
	} else
	
	passivate();
	
	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &Motor::outputFunction( const InternalMessage &msg )
{
	if (this->estado == iniciando) {

		sendOutput( msg.time(), motor_out, this->tiempo );	
	
	} else 
	
	if (this->estado == apagando) {

		sendOutput( msg.time(), motor_out, 0 );
		sendOutput( msg.time(), fin_motor, 1 );	
	
	}

	return *this;
}

Motor::~Motor()
{
//	delete dist;
}
