/*******************************************************************
*
*  DESCRIPTION: Atomic Model Motor
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: joagsa@dc.uba.ar
*
*
*  DATE: 24/09/2004
*
*******************************************************************/
#ifndef __MOTOR_H
#define __MOTOR_H

/** include files **/
#include "atomic.h"  // class Atomic


/** declarations **/
class Motor: public Atomic
{
public:
	Motor( const string &name = "Motor" ) ;	 // Default constructor

	~Motor();					// Destructor
	enum estado {espera, iniciando, marchando, apagando};
	virtual string className() const
		{return "Motor";}

protected:
	Model &initFunction()
		{    estado = espera;
             tiempo = 0; //1-2-3
             return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &motor_in ;
	Port &fin_motor ;
    Port &motor_out;

    int estado;
    int tiempo;


};	// class Motor


#endif    //__MOTOR_H
