/*******************************************************************
*
*  DESCRIPTION: Atomic Model Programa
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: joagsa@dc.uba.ar
*
*
*  DATE: 24/09/2004
*
*******************************************************************/
#ifndef __PROGRAMA_H
#define __PROGRAMA_H

/** include files **/
#include "atomic.h"  // class Atomic

/** forward declarations **/
class Distribution ;

/** declarations **/
class Programa: public Atomic
{
public:
	Programa( const string &name = "Programa" ) ;	 // Default constructor

	~Programa();					// Destructor

	virtual string className() const
		{return "Programa";}

protected:
	Model &initFunction()
		{    habilitado = true;
             prog_nro = 1;
             return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &prog_in ;
	const Port &set_prog ;
	const Port &habilitar ;
    Port & prog_out;

    int prog_nro;
    bool habilitado;

};	// class Programa


#endif    //__PROGRAMA_H
