/*******************************************************************
*
*  DESCRIPTION: Atomic Model PIN Verifier
*
*  AUTHOR: AUTHOR: Hesham Saadawi
*
*  EMAIL: mailto://hsaadawi@scs.carleton.ca
*
*
*  DATE: 18/10/2002
*
*******************************************************************/

/** include files **/
#include <math.h>            // fabs( ... )
#include <stdlib.h>           // for rand function.
#include "Temperatura.h"     // base header
#include "message.h"        // InternalMessage ....
#include "distri.h"        // class Distribution
#include "mainsimu.h"      // class MainSimulator
#include "strutil.h"       // str2float( ... )

/*******************************************************************
* Function Name: Balanceverifier
* Description: constructor
********************************************************************/
Temperatura::Temperatura( const string &name )
: Atomic( name )
, temp_in( addInputPort( "temp_in" ) )
, set_temp( addInputPort( "set_temp" ) )
, habilitar( addInputPort( "habilitar" ) )
, temp_out( addOutputPort( "temp_out" ) )
{
/*	try
	{
		dist = Distribution::create( MainSimulator::Instance().getParameter( description(), "distribution" ) );

		MASSERT( dist );

		for ( register int i = 0 ; i < dist->varCount() ; i++ )
		{
			string parameter( MainSimulator::Instance().getParameter( description(), dist->getVar(i) ) ) ;
			dist->setVar( i, str2float( parameter ) ) ;
		}
	} catch( InvalidDistribution &e )
	{
		e.addText( "The model " + description() + " has distribution problems!" ) ;
		e.print(cerr);
		MTHROW( e ) ;
	} catch( MException &e )
	{
		MTHROW( e ) ;
	}
*/
}

/*******************************************************************
* Function Name: externalFunction
* Description: the PINverifier receives the Amount
********************************************************************/
Model &Temperatura::externalFunction( const ExternalMessage &msg )
{
/*   if ( this->state() == passive)
   {
	holdIn( active, Time( static_cast<float>( fabs( distribution().get() ) ) ) ) ;
    pin = (int) msg.value();
    // According to CD++ manual, random() fn should return a number
    // between 0 and 1. But this doesn't happen and it returns a number
    // of 10 digits.
    //randnumber = random()/1e+10;

    randnumber = (double)rand()/(double)RAND_MAX;
    if ( randnumber <= 0.9)
       {
        PIN_OK = 1;
        no_of_trials = 0;   //Once I get PIN OK, I delete history
       }
    else
        {
        PIN_OK = 0;
        no_of_trials = no_of_trials + 1;
        }
    // assume the PIN is always OK for testing puposes
    //PIN_OK = 0;
   }
*/
	if (msg.port() == temp_in) {

		if (habilitado) {

			//this->estado = EnviandoValor;
			this->temp_nro ++;
			if (this->temp_nro == 4) {
				this->temp_nro = 1;
			}
			passivate();
		 
		}
	
	} else 
	
	if (msg.port() == set_temp) {

		if (habilitado) {
	
			holdIn(active,0);	 
	
		}
	
	} else
	 
	if (msg.port()==habilitar){
	
		if ((int) msg.value() == 1) {
			this->habilitado = true;
		} else
		if ((int) msg.value() == 0) {
			this->habilitado = false;
		}
		passivate();
	}
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &Temperatura::internalFunction( const InternalMessage & )
{
/*      if ( PIN_OK == 0 && no_of_trials >= 3)
         // Reset no_of_trials as card has been ejected
         {
             no_of_trials = 0;
         }
*/
	passivate();

	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &Temperatura::outputFunction( const InternalMessage &msg )
{

/*      if ( PIN_OK == 1)
         sendOutput( msg.time(), get_amnt, 1 );
      else
        if ( no_of_trials < 3)
         //ask to repeat PIN entry
        {
         //sendOutput( msg.time(), get_amnt, randnumber );   // for testing only
          sendOutput( msg.time(), get_pin, 1 );
         }
        else
          // exceeded 3 trials, then eject the card
          {
            sendOutput( msg.time(), eject, 1 );
          }
*/
	sendOutput( msg.time(), temp_out, temp_nro );
	return *this;
}

Temperatura::~Temperatura()
{
//	delete dist;
}
