/*******************************************************************
*
*  DESCRIPTION: Atomic Model PIN Verifier
*
*  AUTHOR: Hesham Saadawi
*
*  EMAIL: hsaadawi@scs.carleton.ca
*
*
*  DATE: 18/10/2002
*
*******************************************************************/
#ifndef __TEMPERATURA_H
#define __TEMPERATURA_H

/** include files **/
#include "atomic.h"  // class Atomic

/** forward declarations **/
class Distribution ;

/** declarations **/
class Temperatura: public Atomic
{
public:
	Temperatura( const string &name = "Temperatura" ) ;	 // Default constructor

	~Temperatura();					// Destructor

	virtual string className() const
		{return "Temperatura";}

protected:
	Model &initFunction()
		{    habilitado = true;
             temp_nro = 1;
             return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &temp_in ;
	const Port &set_temp ;
	const Port &habilitar ;
    Port & temp_out;

    int temp_nro;
    bool habilitado;

};	// class Temperatura


#endif    //__TEMPERATURA_H
