/*******************************************************************
*
*  DESCRIPTION: Atomic Model Temperatura
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: jogasa@dc.uba.ar
*
*
*  DATE: 24/09/2004
*
*******************************************************************/

/** include files **/
#include <math.h>            // fabs( ... )
#include <stdlib.h>           // for rand function.
#include "Temperatura.h"     // base header
#include "message.h"        // InternalMessage ....
#include "distri.h"        // class Distribution
#include "mainsimu.h"      // class MainSimulator
#include "strutil.h"       // str2float( ... )

/*******************************************************************
* Function Name: Temperatura
* Description: constructor
********************************************************************/
Temperatura::Temperatura( const string &name )
: Atomic( name )
, temp_in( addInputPort( "temp_in" ) )
, set_temp( addInputPort( "set_temp" ) )
, habilitar( addInputPort( "habilitar" ) )
, temp_out( addOutputPort( "temp_out" ) )
{
/*	try
	{
		dist = Distribution::create( MainSimulator::Instance().getParameter( description(), "distribution" ) );

		MASSERT( dist );

		for ( register int i = 0 ; i < dist->varCount() ; i++ )
		{
			string parameter( MainSimulator::Instance().getParameter( description(), dist->getVar(i) ) ) ;
			dist->setVar( i, str2float( parameter ) ) ;
		}
	} catch( InvalidDistribution &e )
	{
		e.addText( "The model " + description() + " has distribution problems!" ) ;
		e.print(cerr);
		MTHROW( e ) ;
	} catch( MException &e )
	{
		MTHROW( e ) ;
	}
*/
}

/*******************************************************************
* Function Name: externalFunction
* Description: the PINverifier receives the Amount
********************************************************************/
Model &Temperatura::externalFunction( const ExternalMessage &msg )
{
	if (msg.port() == temp_in) {

		if (habilitado) {

			//this->estado = EnviandoValor;
			this->temp_nro ++;
			if (this->temp_nro == 4) {
				this->temp_nro = 1;
			}
			passivate();
		 
		}
	
	} else 
	
	if (msg.port() == set_temp) {

		if (habilitado) {
	
			holdIn(active,0);	 
	
		}
	
	} else
	 
	if (msg.port()==habilitar){
	
		if ((int) msg.value() == 1) {
			this->habilitado = true;
		} else
		if ((int) msg.value() == 0) {
			this->habilitado = false;
		}
		passivate();
	} else
	
	passivate();
	
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &Temperatura::internalFunction( const InternalMessage & )
{
	passivate();

	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &Temperatura::outputFunction( const InternalMessage &msg )
{

	sendOutput( msg.time(), temp_out, temp_nro );
	return *this;
}

Temperatura::~Temperatura()
{
//	delete dist;
}
