/*******************************************************************
*
*  DESCRIPTION: Atomic Model UC
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: joagsa@dc.uba.ar
*
*
*  DATE: 24/09/2004
*
*******************************************************************/
#ifndef __UC_H
#define __UC_H

/** include files **/
#include "atomic.h"  // class Atomic


/** declarations **/
class UC: public Atomic
{
public:
	UC( const string &name = "UC" ) ;	 // Default constructor

	~UC();					// Destructor
	enum estado {einicio, eagua, edet, emotor};
	virtual string className() const
		{return "UC";}

protected:
	Model &initFunction()
		{    estado = einicio;
             temp = 1;
             nro_prog = 1;
             habilitado = true;
             return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &prog_in;
	const Port &temp_in;
	const Port &start_in;
	const Port &fin_agua;
	const Port &fin_det;
	const Port &fin_motor;
	Port &habilitar;
	Port &agua_out;
	Port &det_out;
    Port &motor_out;

    int estado;
    int temp;
    int nro_prog;
    bool habilitado;


};	// class UC


#endif    //__UC_H
