/*******************************************************************
*
*  DESCRIPTION: Atomic Model AGUA
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: jogasa@dc.uba.ar
*
*
*  DATE: 23/09/2004
*
*******************************************************************/

/** include files **/
#include <math.h>            // fabs( ... )
#include <stdlib.h>           // for rand function.
#include "Agua.h"     // base header
#include "message.h"        // InternalMessage ....
#include "distri.h"        // class Distribution
#include "mainsimu.h"      // class MainSimulator
#include "strutil.h"       // str2float( ... )

/*******************************************************************
* Function Name: Agua
* Description: constructor
********************************************************************/
Agua::Agua( const string &name )
: Atomic( name )
, agua_in( addInputPort( "agua_in" ) )
, agua_out( addOutputPort( "agua_out" ) )
, fin_agua( addOutputPort( "fin_agua" ) )
{
/*	try
	{
		dist = Distribution::create( MainSimulator::Instance().getParameter( description(), "distribution" ) );

		MASSERT( dist );

		for ( register int i = 0 ; i < dist->varCount() ; i++ )
		{
			string parameter( MainSimulator::Instance().getParameter( description(), dist->getVar(i) ) ) ;
			dist->setVar( i, str2float( parameter ) ) ;
		}
	} catch( InvalidDistribution &e )
	{
		e.addText( "The model " + description() + " has distribution problems!" ) ;
		e.print(cerr);
		MTHROW( e ) ;
	} catch( MException &e )
	{
		MTHROW( e ) ;
	}
*/
}

/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &Agua::externalFunction( const ExternalMessage &msg )
{
	if (this->estado == espera) {

		this->cant_agua = (int) msg.value() % 100 ;
		this->temp = (msg.value() - this->cant_agua) / 100 ;
		this->estado = iniciando;
		holdIn(active,0);
	
	} else 
	
	passivate();
	
	
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &Agua::internalFunction( const InternalMessage & )
{
	if (this->estado == iniciando) {

		this->estado = calentando;
		Time t (0, 0, this->temp, 0);
		holdIn(active,t);
	
	} else 
	
	if (this->estado == calentando) {

		this->estado = enviando;
		Time a (0, 0, this->cant_agua, 0);
		holdIn(active, a);	 
	
	
	} else
	 
	if (this->estado == enviando){
	
		this->estado = fin;
		holdIn(active,0);

	} else

	if (this->estado == fin) {
		this->cant_agua = 0;
		this->temp=0;
		this->estado = espera;
		passivate();
	} else
	
	passivate();

	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &Agua::outputFunction( const InternalMessage &msg )
{
	if (this->estado == iniciando) {

		sendOutput( msg.time(), agua_out, this->cant_agua );	
	
	} else 
	
	if (this->estado == fin) {

		sendOutput( msg.time(), agua_out, 0 );
		sendOutput( msg.time(), fin_agua, 1 );	
	
	}

	return *this;
}

Agua::~Agua()
{
//	delete dist;
}
