/*******************************************************************
*
*  DESCRIPTION: Atomic Model Detergente
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: jogasa@dc.uba.ar
*
*
*  DATE: 24/09/2004
*
*******************************************************************/
#ifndef __DETERGENTE_H
#define __DETERGENTE_H

/** include files **/
#include "atomic.h"  // class Atomic


/** declarations **/
class Detergente: public Atomic
{
public:
	Detergente( const string &name = "Detergente" ) ;	 // Default constructor

	~Detergente();					// Destructor
	enum estado {espera, iniciando, enviando, fin};
	virtual string className() const
		{return "Detergente";}

protected:
	Model &initFunction()
		{    estado = espera;
             cant_det = 0; //1-2-3
             return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &det_in ;
	Port &fin_det ;
    Port &det_out;

    int estado;
    int cant_det;


};	// class Detergente


#endif    //__DETERGENTE_H
