/*******************************************************************
*
*  DESCRIPTION: Atomic Model Programa
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: jogasa@dc.uba.ar
*
*
*  DATE: 23/09/2004
*
*******************************************************************/

/** include files **/
#include <math.h>            // fabs( ... )
#include <stdlib.h>           // for rand function.
#include "Programa.h"     // base header
#include "message.h"        // InternalMessage ....
#include "distri.h"        // class Distribution
#include "mainsimu.h"      // class MainSimulator
#include "strutil.h"       // str2float( ... )

/*******************************************************************
* Function Name: Programa
* Description: constructor
********************************************************************/
Programa::Programa( const string &name )
: Atomic( name )
, prog_in( addInputPort( "prog_in" ) )
, set_prog( addInputPort( "set_prog" ) )
, habilitar( addInputPort( "habilitar" ) )
, prog_out( addOutputPort( "prog_out" ) )
{
/*	try
	{
		dist = Distribution::create( MainSimulator::Instance().getParameter( description(), "distribution" ) );

		MASSERT( dist );

		for ( register int i = 0 ; i < dist->varCount() ; i++ )
		{
			string parameter( MainSimulator::Instance().getParameter( description(), dist->getVar(i) ) ) ;
			dist->setVar( i, str2float( parameter ) ) ;
		}
	} catch( InvalidDistribution &e )
	{
		e.addText( "The model " + description() + " has distribution problems!" ) ;
		e.print(cerr);
		MTHROW( e ) ;
	} catch( MException &e )
	{
		MTHROW( e ) ;
	}
*/
}

/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &Programa::externalFunction( const ExternalMessage &msg )
{
	if (msg.port() == prog_in) {

		if (habilitado) {

			this->prog_nro ++;
			if (this->prog_nro == 4) {
				this->prog_nro = 1;
			}
			passivate();
		 
		}
	
	} else 
	
	if (msg.port() == set_prog) {

		if (habilitado) {
	
			holdIn(active,0);	 
	
		}
	
	} else
	 
	if (msg.port()==habilitar){
	
		if ((int) msg.value() == 1) {
			this->habilitado = true;
		} else
		if ((int) msg.value() == 0) {
			this->habilitado = false;
		}
		passivate();
	} else
	
	passivate();
	
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &Programa::internalFunction( const InternalMessage & )
{
	passivate();

	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &Programa::outputFunction( const InternalMessage &msg )
{

	sendOutput( msg.time(), prog_out, prog_nro );
	return *this;
}

Programa::~Programa()
{
//	delete dist;
}
