/*******************************************************************
*
*  DESCRIPTION: Atomic Model UC
*
*  AUTHOR: Ogasawara Javier
*
*  EMAIL: jogasa@dc.uba.ar
*
*
*  DATE: 23/09/2004
*
*******************************************************************/

/** include files **/
#include <math.h>            // fabs( ... )
#include <stdlib.h>           // for rand function.
#include "UC.h"     // base header
#include "message.h"        // InternalMessage ....
#include "distri.h"        // class Distribution
#include "mainsimu.h"      // class MainSimulator
#include "strutil.h"       // str2float( ... )

/*******************************************************************
* Function Name: UC
* Description: constructor
********************************************************************/
UC::UC( const string &name )
: Atomic( name )
, prog_in( addInputPort( "prog_in" ) )
, temp_in( addInputPort( "temp_in" ) )
, start_in( addInputPort( "start_in" ) )
, fin_agua( addInputPort( "fin_agua" ) )
, fin_det( addInputPort( "fin_det" ) )
, fin_motor( addInputPort( "fin_motor" ) )
, motor_out( addOutputPort( "motor_out" ) )
, det_out( addOutputPort( "det_out" ) )
, agua_out( addOutputPort( "agua_out" ) )
, habilitar( addOutputPort( "habilitar" ) )
{
/*	try
	{
		dist = Distribution::create( MainSimulator::Instance().getParameter( description(), "distribution" ) );

		MASSERT( dist );

		for ( register int i = 0 ; i < dist->varCount() ; i++ )
		{
			string parameter( MainSimulator::Instance().getParameter( description(), dist->getVar(i) ) ) ;
			dist->setVar( i, str2float( parameter ) ) ;
		}
	} catch( InvalidDistribution &e )
	{
		e.addText( "The model " + description() + " has distribution problems!" ) ;
		e.print(cerr);
		MTHROW( e ) ;
	} catch( MException &e )
	{
		MTHROW( e ) ;
	}
*/
}

/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &UC::externalFunction( const ExternalMessage &msg )
{
	if (msg.port() == prog_in) {
		if (this->estado == einicio) {
			this->nro_prog = (int) msg.value() ;
		}
		passivate();
	} else
	 
	if (msg.port() == temp_in) {
		if (this->estado == einicio) {
			this->temp = (int) msg.value();
		}
		passivate();  
	} else
	if (msg.port() == start_in) {
		if (this->estado == einicio) {
			this->estado = eagua;
			this->habilitado = false;
			holdIn(active,0);
		} 
		else
			passivate();
	} else
	if (msg.port() == fin_agua) {
		if (this->estado == eagua) {
			this->estado = edet;
			holdIn(active,0);
		}
		else
			passivate();
	} else
	if (msg.port() == fin_det) {
		if (this->estado == edet) {
			this->estado = emotor;
			holdIn(active,0);
		}
		else
			passivate();
	} else
	
	if (msg.port() == fin_motor) {
		if (this->estado == emotor) {
			this->estado = einicio;
			habilitado = true;
			holdIn(active,0);
		}
//		else
//			passivate();
	} 
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &UC::internalFunction( const InternalMessage & )
{
	passivate();	
	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &UC::outputFunction( const InternalMessage &msg )
{
	if (this->estado == edet) {
		sendOutput( msg.time(), det_out, this->nro_prog * 10);
	} 
	if (this->estado == emotor) {
		sendOutput( msg.time(), motor_out, this->nro_prog * 30 );
	} 
	if (this->estado == einicio) {
		sendOutput( msg.time(), habilitar,  this->habilitado );
	}
	if (this->estado == eagua) {
		int valor = (this->temp*25)*100;
		valor = valor + (this->nro_prog * 30); //converti el mensaje en 4 cifras
		sendOutput( msg.time(), agua_out, valor );	
		sendOutput( msg.time(), habilitar, this->habilitado );
	} 
	
	return *this;
}

UC::~UC()
{
//	delete dist;
}
